package com.izouma.awesomeadmin.web;

import java.util.*;

import com.google.gson.Gson;
import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.QueryConfig;
import com.izouma.awesomeadmin.service.QueryConfigService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/queryConfig")
public class QueryConfigController {

    @Autowired
    private QueryConfigService queryConfigService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(QueryConfig record) {
        List<QueryConfig> pp = queryConfigService.getQueryConfigList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getQueryConfig", method = RequestMethod.GET)
    @ResponseBody
    public Result getQueryConfig(@RequestParam(required = false, value = "id") String id) {
        QueryConfig data = queryConfigService.getQueryConfigById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(QueryConfig record) {
        QueryConfig data = queryConfigService.getQueryConfig(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, QueryConfig record) {
        Map<String, Object> result = new HashMap<>();

        List<QueryConfig> pp = queryConfigService.getQueryConfigByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(@RequestBody QueryConfig record) {

        Gson gson = new Gson();
        record.setConfigJson(gson.toJson(record.getFields()));
        record.setSubJson(gson.toJson(record.getSubtables()));

        boolean num = queryConfigService.createQueryConfig(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateQueryConfig(@RequestBody QueryConfig record) {

        Gson gson = new Gson();
        record.setConfigJson(gson.toJson(record.getFields()));
        record.setSubJson(gson.toJson(record.getSubtables()));

        boolean num = queryConfigService.updateQueryConfig(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteQueryConfig(@RequestParam(required = true, value = "id") String id) {

        boolean num = queryConfigService.deleteQueryConfig(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, QueryConfig record) throws Exception {

        List<QueryConfig> queryConfigs = queryConfigService.getQueryConfigList(record);


        String sheetName = "query_config";
        String titleName = "通用查询配置数据表";
        String fileName = "通用查询配置表";
        int columnNumber = 6;
        int[] columnWidth = {20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "code", "表名", "字段", "数据库类型"};
        String[][] dataList = new String[queryConfigs.size()][6];

        for (int i = 0; i < queryConfigs.size(); i++) {

            dataList[i][0] = String.valueOf(queryConfigs.get(i).getId());
            dataList[i][1] = String.valueOf(queryConfigs.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(queryConfigs.get(i).getCode());
            dataList[i][3] = String.valueOf(queryConfigs.get(i).getTableName());
            dataList[i][4] = String.valueOf(queryConfigs.get(i).getTablecolumns());
            dataList[i][5] = String.valueOf(queryConfigs.get(i).getDatabasetype());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

